
_ini_uart:
;uart.c,12 :: 		void ini_uart(void)
;uart.c,14 :: 		TMOD=0X20;
	MOV TMOD+0, #32
;uart.c,15 :: 		SCON=0X50;
	MOV SCON+0, #80
;uart.c,16 :: 		TH1=0XF3;
	MOV TH1+0, #243
;uart.c,17 :: 		TL1=0XF3;
	MOV TL1+0, #243
;uart.c,19 :: 		TCON.TR1=1;
	SETB TCON+0
;uart.c,20 :: 		}
	RET
; end of _ini_uart

_tx:
;uart.c,22 :: 		void tx(unsigned char x)
;uart.c,24 :: 		SBUF=x;
	MOV SBUF+0, FARG_tx_x+0
;uart.c,25 :: 		while(SCON.TI==0);
L_tx0:
	JB SCON+0, L_tx1
	NOP
	SJMP L_tx0
L_tx1:
;uart.c,26 :: 		SCON.TI=0;
	CLR SCON+0
;uart.c,27 :: 		}
	RET
; end of _tx

_send:
;uart.c,29 :: 		void send(const unsigned char* str)
;uart.c,31 :: 		while(*str)
L_send2:
	MOV 130, FARG_send_str+0
	MOV 131, FARG_send_str+1
	CLR A
	MOVC A, @A+DPTR
	MOV R0, A
	JZ L_send3
;uart.c,32 :: 		tx(*str++);
	MOV 130, FARG_send_str+0
	MOV 131, FARG_send_str+1
	CLR A
	MOVC A, @A+DPTR
	MOV R0, A
	MOV FARG_tx_x+0, 0
	LCALL _tx+0
	MOV A, #1
	ADD A, FARG_send_str+0
	MOV FARG_send_str+0, A
	MOV A, #0
	ADDC A, FARG_send_str+1
	MOV FARG_send_str+1, A
	SJMP L_send2
L_send3:
;uart.c,33 :: 		}
	RET
; end of _send

_main:
	MOV SP+0, #128
;uart.c,36 :: 		void main()
;uart.c,38 :: 		char i=1,rcvd;
	MOV main_i_L0+0, #1
;uart.c,39 :: 		LCD_RW = 0;
	CLR P2_1_bit+0
;uart.c,40 :: 		UART1_Init(9600);
	MOV TH1+0, #253
	MOV TL1+0, #253
	LCALL _UART1_Init+0
;uart.c,43 :: 		Lcd_Init();
	LCALL _Lcd_Init+0
;uart.c,44 :: 		Delay_ms(100);                  // Wait for UART module to stabilize
	MOV R6, 195
	MOV R7, 140
	DJNZ R7, 
	DJNZ R6, 
;uart.c,45 :: 		Lcd_Out(1,1,"AT89s52 Ready");
	MOV FARG_LCD_Out_row+0, #1
	MOV FARG_LCD_Out_column+0, #1
	MOV FARG_LCD_Out_text+0, #?lstr1_uart+0
	LCALL _LCD_Out+0
;uart.c,46 :: 		Lcd_Out(2,1,"Synchronizing");
	MOV FARG_LCD_Out_row+0, #2
	MOV FARG_LCD_Out_column+0, #1
	MOV FARG_LCD_Out_text+0, #?lstr2_uart+0
	LCALL _LCD_Out+0
;uart.c,47 :: 		Delay_ms(500);
	MOV R5, 4
	MOV R6, 205
	MOV R7, 189
	DJNZ R7, 
	DJNZ R6, 
	DJNZ R5, 
	NOP
;uart.c,48 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOV FARG_Lcd_Cmd_out_char+0, #1
	LCALL _Lcd_Cmd+0
;uart.c,50 :: 		while(1)
L_main4:
;uart.c,52 :: 		Delay_ms(500);
	MOV R5, 4
	MOV R6, 205
	MOV R7, 189
	DJNZ R7, 
	DJNZ R6, 
	DJNZ R5, 
	NOP
;uart.c,53 :: 		Lcd_Out(1,1,"Sending 'Y'");
	MOV FARG_LCD_Out_row+0, #1
	MOV FARG_LCD_Out_column+0, #1
	MOV FARG_LCD_Out_text+0, #?lstr3_uart+0
	LCALL _LCD_Out+0
;uart.c,54 :: 		tx('Y');
	MOV FARG_tx_x+0, #89
	LCALL _tx+0
;uart.c,56 :: 		while(!UART1_Data_Ready());
L_main6:
	LCALL _UART1_Data_Ready+0
	MOV A, R0
	JNZ L_main7
	SJMP L_main6
L_main7:
;uart.c,57 :: 		if (UART1_Data_Ready())
	LCALL _UART1_Data_Ready+0
	MOV A, R0
	JZ L_main8
;uart.c,59 :: 		rcvd = UART1_Read();
	LCALL _UART1_Read+0
	MOV main_rcvd_L0+0, 0
;uart.c,60 :: 		SCON.RI=0;
	CLR SCON+0
;uart.c,62 :: 		}
L_main8:
;uart.c,63 :: 		if(rcvd == 'Y')
	MOV A, main_rcvd_L0+0
	XRL A, #89
	JNZ L_main9
;uart.c,65 :: 		Lcd_Out(1,1,"^_^");
	MOV FARG_LCD_Out_row+0, #1
	MOV FARG_LCD_Out_column+0, #1
	MOV FARG_LCD_Out_text+0, #?lstr4_uart+0
	LCALL _LCD_Out+0
;uart.c,67 :: 		}
	SJMP L_main10
L_main9:
;uart.c,68 :: 		else  Lcd_Out(1,1,"?? ");
	MOV FARG_LCD_Out_row+0, #1
	MOV FARG_LCD_Out_column+0, #1
	MOV FARG_LCD_Out_text+0, #?lstr5_uart+0
	LCALL _LCD_Out+0
L_main10:
;uart.c,69 :: 		}
	SJMP L_main4
;uart.c,71 :: 		}
	SJMP #254
; end of _main
